QwtPlotRasterItem(3)

NAME
QwtPlotRasterItem -

SYNOPSIS

#include <qwt_plot_rasteritem.h>

Inherits QwtPlotItem.

Inherited by QwtPlotSpectrogram.

  Public Types
enum CachePolicy { NoCache, PaintCache, ScreenCache }

  Public Member Functions
QwtPlotRasterItem (const QString &title=QString::null)
QwtPlotRasterItem (const QwtText &title)
virtual ~QwtPlotRasterItem ()
int alpha () const
CachePolicy cachePolicy () const
virtual void draw (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &rect) const
void invalidateCache ()
virtual QSize rasterHint (const QwtDoubleRect &) const
void setAlpha (int alpha)
void setCachePolicy (CachePolicy)

  Protected Member Functions
virtual QImage renderImage (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QwtDoubleRect &area) const =0

Detailed Description

A class, which displays raster data. Raster data is a grid of pixel values, that can be represented as a QImage. It is used for many types of information like spectrograms, cartograms, geographical maps ...

Often a plot has several types of raster data organized in layers. ( f.e a geographical map, with weather statistics ). Using setAlpha() raster items can be stacked easily.

QwtPlotRasterItem is only implemented for images of the following formats: QImage::Format_Indexed8, QImage::Format_ARGB32.

See also:
    QwtPlotSpectrogram

Member Enumeration Documentation

  enum QwtPlotRasterItem::CachePolicy

•   NoCache
     renderImage() is called, whenever the item has to be repainted

•   PaintCache
     renderImage() is called, whenever the image cache is not valid, or the scales, or the size of the canvas has changed. This type of cache is only useful for improving the performance of hide/show operations. All other situations are already handled by the plot canvas cache.

•   ScreenCache
     The screen cache is an image in size of the screen. As long as the scales don't change the target image is scaled from the cache. This might improve the performance when resizing the plot widget, but suffers from scaling effects.

The default policy is NoCache

Member Function Documentation

  int QwtPlotRasterItem::alpha () const
Returns:
    Alpha value of the raster item

See also:
    setAlpha()

  QwtPlotRasterItem::CachePolicy QwtPlotRasterItem::cachePolicy () const
Returns:
    Cache policy

See also:
    CachePolicy, setCachePolicy()

  void QwtPlotRasterItem::draw (QPainter *painter, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &canvasRect) const [virtual]

Draw the raster data. Parameters:
    painter Painter
    xMap X-Scale Map
    yMap Y-Scale Map
    canvasRect Contents rect of the plot canvas

Implements QwtPlotItem.

Reimplemented in QwtPlotSpectrogram.

  void QwtPlotRasterItem::invalidateCache ()
Invalidate the paint cache

See also:
    setCachePolicy()

  QSize QwtPlotRasterItem::rasterHint (const QwtDoubleRect &) const [virtual]

Returns the recommended raster for a given rect. F.e the raster hint can be used to limit the resolution of the image that is rendered.

The default implementation returns an invalid size (QSize()), what means: no hint.

Reimplemented in QwtPlotSpectrogram.

  virtual QImage QwtPlotRasterItem::renderImage (const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QwtDoubleRect &area) const [protected], [pure virtual]
Renders an image for an area

The format of the image must be QImage::Format_Indexed8, QImage::Format_RGB32 or QImage::Format_ARGB32

Parameters:
    xMap Maps x-values into pixel coordinates.
    yMap Maps y-values into pixel coordinates.
    area Requested area for the image in scale coordinates

Implemented in QwtPlotSpectrogram.

  void QwtPlotRasterItem::setAlpha (intalpha)

Set an alpha value for the raster data. Often a plot has several types of raster data organized in layers. ( f.e a geographical map, with weather statistics ). Using setAlpha() raster items can be stacked easily.

The alpha value is a value [0, 255] to control the transparency of the image. 0 represents a fully transparent color, while 255 represents a fully opaque color.

Parameters:
    alpha Alpha value

•   alpha >= 0
     All alpha values of the pixels returned by renderImage() will be set to alpha, beside those with an alpha value of 0 (invalid pixels).

•   alpha < 0 The alpha values returned by renderImage() are not changed.

The default alpha value is -1.

See also:
    alpha()

  void QwtPlotRasterItem::setCachePolicy (QwtPlotRasterItem::CachePolicypolicy)
Change the cache policy

The default policy is NoCache

Parameters:
    policy Cache policy

See also:
    CachePolicy, cachePolicy()

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.